#! CRADDON 1
#! NAME YaBB 2 Comments
#! DESCRIPTION Comment your news with YaBB 2.
#! VERSION 1.0
#! DOC 1

$corantourl = $scripturl;

my $addon = new Addon('YaBB 2 Comments');
$addon->checkBuild("29"); 
$addon->isPrivacyCompatible;

$addon->hook('ModifyNews_EditSave_3', 'YaBB_SaveNews');
$addon->hook('SaveNews_1', 'YaBB_SaveNews');
$addon->hook('ModifyNews_Delete_1', 'YaBB_ModifyNews_Delete');
$addon->hook('DisplaySubForm_TopRow','YaBB_DisplaySubForm_TopRow');
$addon->hook('ModifyNews_Edit_TopRow', 'YaBB_ModifyNews_Edit_TopRow');
$addon->hook('ModifyNews_NewColumn_1', 'YaBB_ModifyNews_NewColumn_1');
$addon->hook('ModifyNews_NewColumn_2', 'YaBB_ModifyNews_NewColumn_2');

$addon->addAdvancedSettingHeading('YaBB Addon Settings');
$addon->addAdvancedSetting('YaBB_Path' , 'Url to YaBB' , '(http://www.yoursite.com/cgi-bin/yabb)');
$addon->addAdvancedSetting('YaBB_Abs_Path' , 'Absolute path to YaBB' , 'The absolute path to your YaBB.pl or .cgi (/home/user/html/cgi-bin/yabb)');
$addon->addAdvancedSetting('YaBB_Board_Default', 'YaBB board', 'The default board id of the board your YaBB posts will go into<br>(leave empty to default to not create a thread)');
$addon->addAdvancedSetting('YaBB_User', 'YaBB user', 'The default name that will be displayed as poster in YaBB<br>(max. 18 characters, no spaces or special characters, e.g. News_Reporter)');
$addon->addAdvancedSetting('YaBB_User_Email', 'YaBB email', 'The default posters email address');
$addon->addAdvancedSetting('YaBB_Del_Col_Default', 'YaBB thread delete column default', 'Default value for thread delete selection on Modify News page.<br>(Thread will only be deleted if the newsitem is also deleted)','yn');


NeedCFG();
require "cruser.pl";
$sourcedir = "$CConfig{'YaBB_Abs_Path'}/Sources";
$vardir = "$CConfig{'YaBB_Abs_Path'}/Variables";
$boardsdir = "$CConfig{'YaBB_Abs_Path'}/Boards";
$memberdir = "$CConfig{'YaBB_Abs_Path'}/Members";
$datadir = "$CConfig{'YaBB_Abs_Path'}/Messages";
$YaBB_User = $CConfig{'YaBB_User'};

require "$CConfig{'YaBB_Abs_Path'}/Sources/System.pl";
require "$CConfig{'YaBB_Abs_Path'}/Sources/Security.pl";
require "$CConfig{'YaBB_Abs_Path'}/Sources/Subs.pl";
require "$CConfig{'YaBB_Abs_Path'}/Sources/Load.pl";

$scripturl = $corantourl;

if(!$fieldDB{'CustomField_YaBB_ID'})
	{	
	$addon->addNewsField('CustomField_YaBB_ID', '1', 'YaBB ID#');
	}

if(!$fieldDB{'CustomField_YaBB_Board'})
	{
	$addon->addNewsField('CustomField_YaBB_Board', '3', 'YaBB Board');
	}

sub YaBB_ModifyNews_Edit_TopRow
	{
	if ($CustomField_YaBB_Board eq "")
		{
		&YaBB_DisplaySubForm_TopRow;
		}
	}

sub YaBB_ModifyNews_NewColumn_1
	{
	if ($ColCount % 2) 
		{
		print q~<td class="yellowbg">~;
		} 
	else 
		{
		print q~<td class="lightgbg">~;
		}
	print qq~<div align="center"><b>Del.Thread</b></div></td>~;
	$ColCount++;
	}

sub YaBB_ModifyNews_NewColumn_2
	{
	if ($ColCount % 2) 
		{
		print q~<td class="navlink"><div align="center">~;
		}
	else 
		{
		print q~<td class="lightgbg"><div align="center" class="footnote">~;
		}
	if ($CustomField_YaBB_ID && $CustomField_YaBB_Board)
		{
		if ($CConfig{'YaBB_Del_Col_Default'})
			{
			print qq~<input type="checkbox" value="delete" checked name="YaBB_Del-$newsid">~;
			}
		else
			{
			print qq~<input type="checkbox" value="delete" name="YaBB_Del-$newsid">~;
			}
		}
	else
		{
		print "&nbsp;";
		}
	print '</div></td>';
	$ColCount++;
	}

sub YaBB_DisplaySubForm_TopRow
	{

	&LoadMyUser;
	&Y_BoardTotals("load", $CConfig{'YaBB_Board_Default'});

	my ($line, $YaBB_Category);
	print qq~\n<tr><td width="30%" class="fieldtitle" valign="top"><div align="right">YaBB Board:</div></td><td width="70%"><select name="CustomField_YaBB_Board">\n~;
	if (!($CConfig{'YaBB_Board_Default'}))
		{
		print qq~<option value="" selected>None</option>\n~;
		}
	else
		{
		print qq~<option value="">None</option>\n~;
		}
	require "$boardsdir/forum.master";
	foreach $catid (@categoryorder) {
		$boardlist = $cat{$catid};
		(@bdlist) = split(/\,/, $boardlist);
		($catname, $catperms) = split(/\|/, $catinfo{"$catid"});

		foreach $board (@bdlist) {
			($boardname, $boardperms, $boardview) = split(/\|/, $board{"$board"});
			&ToChars($boardname);

			if ($board eq $CConfig{'YaBB_Board_Default'}) { print "<option selected=\"selected\" value=\"$board\">$boardname</option>\n"; }
			else { print "<option value=\"$board\">$boardname</option>\n"; }
		}
	}
	print qq~</select><br />Scripturl = $scripturl<br />Coranto URL = $corantourl<br />YaBB Username = $YaBB_User<!-- $output --></td></tr>\n~;
	}

sub YaBB_SaveNews
	{
	if ($CustomField_YaBB_Board ne "")
		{

		my($yabbnewthreadid, $newthreadcount, $newmessagecount, $oldmessagecount, $oldmessagestate, $line, $mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate, $YaBB_User, $YaBB_User_Email);
		require 'crlib.pl';
		&ReadUserDBInfo();
		&InitUserFieldVars();
		# If the user provided YaBB-account information, use it.
		$YaBB_User = $CConfig{'YaBB_User'};
		$YaBB_User_Email = $CConfig{'YaBB_User_Email'};

		$user = $YaBB_User;
		&LoadMyUser;

		&BasicDateVars(time);
		my $YaBB_Time = time;
		# Check if a thread ID exists for the newsitem. Create one if necessary.
		if( $CustomField_YaBB_ID eq '' || !(-e "$datadir/$CustomField_YaBB_ID.txt")) 
			{
			$yabbnewthreadid = time;
			my $i=0;
			if (-e "$CConfig{'YaBB_Abs_Path'}/Messages/$yabbnewthreadid.txt") 
				{
				while (-e "$CConfig{'YaBB_Abs_Path'}/Messages/$yabbnewthreadid.txt")
					{
					++$i;
					}
				$yabbnewthreadid="$yabbnewthreadid$i";
				}
			$CustomField_YaBB_ID = "$yabbnewthreadid";
			}
		else 
			{ 
			$yabbnewthreadid = $CustomField_YaBB_ID; 
			}
		&YaBB_PostNews;
		$scripturl = $corantourl;
		}

	}

sub YaBB_ModifyNews_Delete 
	{
	if (($CustomField_YaBB_Board ne "") && ($in{"del-$newsid"} eq 'del') && ($in{"YaBB_Del-$newsid"} eq 'delete'))
		{
		# Count thread posts and remove the thread from boardindex 
		my ($oldmessagecount, $buffer, $line, $mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate, $YaBB_User, $YaBB_User_Email);
		require 'crlib.pl';
		&ReadUserDBInfo();
		&InitUserFieldVars();
		# If the user provided YaBB-account information, use it.
		if ($userdata{$CurrentUser}->{'YaBB_UserName'} ne "")
			{
			$YaBB_User = $userdata{$CurrentUser}->{'YaBB_UserName'};
			if ($userdata{$CurrentUser}->{'YaBB_UserEmail'} ne "")
				{
				$YaBB_User_Email = $userdata{$CurrentUser}->{'YaBB_UserEmail'};
				}
			else
				{
				$YaBB_User_Email = $CConfig{'YaBB_User_Email'};
				}
			}
		else
			{
			$YaBB_User = $CConfig{'YaBB_User'};
			$YaBB_User_Email = $CConfig{'YaBB_User_Email'};
			}
		open(YABB_FILE, "+<$CConfig{'YaBB_Abs_Path'}/Boards/$CustomField_YaBB_Board.txt") || $addon->fatalError("401 An error has occured!: Unable to open $CustomField_YaBB_Board.txt");
		if ($UseFlock) 
			{
			flock(YABB_FILE, 2) || $addon->fatalError("Could not obtain an exclusive lock on file $CustomField_YaBB_Board.txt"); 
			}
		seek YABB_FILE, 0, 0;
		open(TEMP, "+>$CConfig{'YaBB_Abs_Path'}/Boards/$CustomField_YaBB_Board.txt.temp") || $addon->fatalError("402 An error has occured!: Unable to open $CConfig{'YaBB_Abs_Path'}/Boards/$CustomField_YaBB_Board.txt.temp");
		seek TEMP, 0, 0;
		while( read(YABB_FILE,$buffer,1024) ) 
			{
			print TEMP $buffer;
			}
		truncate YABB_FILE, 0;
		seek YABB_FILE, 0, 0;
		seek TEMP, 0, 0;
		while( $line = <TEMP> ) 
			{
			($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate) = split(/\|/,$line);
			if ($mnum != $CustomField_YaBB_ID)
				{
				print YABB_FILE $line;
				}
			else		
				{
				$mreplies++;
				$oldmessagecount = $mreplies;
				}
			}
		close(TEMP);
		if (-e "$CConfig{'YaBB_Abs_Path'}/Boards/$CustomField_YaBB_Board.txt.temp") 
			{
			unlink("$CConfig{'YaBB_Abs_Path'}/Boards/$CustomField_YaBB_Board.txt.temp"); 
			}
		close(YABB_FILE);

		# Replace last poster with N/A
		open(YABB_FILE, "+<$CConfig{'YaBB_Abs_Path'}/Boards/$CustomField_YaBB_Board.poster") || $addon->fatalError("403 An error has occured!: Unable to open $CustomField_YaBB_Board.poster");
		if ($UseFlock) 
			{
			flock(YABB_FILE, 2) || $addon->fatalError("Could not obtain an exclusive lock on file $CustomField_YaBB_Board.poster"); 
			}
		truncate YABB_FILE, 0;
		seek YABB_FILE, 0, 0;
		print YABB_FILE qq~N/A~;
		close(YABB_FILE);
	
		# Edit board totals to reflect changed thread/post count
		open(YABB_FILE, "+<$CConfig{'YaBB_Abs_Path'}/Boards/$CustomField_YaBB_Board.ttl");
		if ($UseFlock) 
			{
			flock(YABB_FILE, 2) || $addon->fatalError("Could not obtain an exclusive lock on file $CustomField_YaBB_Board.ttl"); 
			}
		my $tmp = <YABB_FILE>;
		chomp $tmp;
		my ($TTL_threadcount, $TTL_messagecount, $TTL_lastposttime, $TTL_lastposter) = split(/\|/,$tmp);
		$TTL_threadcount--;
		$TTL_messagecount -= $oldmessagecount;
		$TTL_lastposttime = "N/A";
		$TTL_lastposter = "N/A";
		truncate YABB_FILE, 0;
		seek YABB_FILE, 0, 0;
		print YABB_FILE qq~$TTL_threadcount|$TTL_messagecount|$TTL_lastposttime|$TTL_lastposter~;
		close(YABB_FILE);

		# Update postcount in user profile if user exists
		if ((-e "$CConfig{'YaBB_Abs_Path'}/Members/$YaBB_User.dat") && (-e "$CConfig{'YaBB_Abs_Path'}/Messages/$CustomField_YaBB_ID.txt"))
			{
			open(YABB_FILE, "<$CConfig{'YaBB_Abs_Path'}/Messages/$CustomField_YaBB_ID.txt") || $addon->fatalError("404 An error has occured!: Unable to open $CustomField_YaBB_ID.txt");
			my $line;
			my $YaBB_UPP_tmp = 0;
			while ($line = <YABB_FILE>)
				{
				my ($Y_tmp1,$Y_User,$Y_tmp2,$Y_tmp3,$Y_tmp4,$Y_tmp5,$Y_tmp6,$Y_tmp7,$Y_tmp8,$Y_tmp9,$Y_tmp10)  = split(/\|/,$line);
				if ($Y_User eq $YaBB_User)
					{
					$YaBB_UPP_tmp++;
					}
				}
			close(YABB_FILE);
			open(YABB_FILE, "+<$CConfig{'YaBB_Abs_Path'}/Members/$YaBB_User.dat") || $addon->fatalError("405 An error has occured!: Unable to open $YaBB_User.dat");
			if ($UseFlock) 
				{
				flock(YABB_FILE, 2) || $addon->fatalError("Could not obtain an exclusive lock on file $YaBB_User.dat"); 
				}
			seek YABB_FILE, 0, 0;
			open(TEMP, "+>$CConfig{'YaBB_Abs_Path'}/Members/$YaBB_User.dat.temp") || $addon->fatalError("406 An error has occured!: Unable to open $YaBB_User.dat.temp");
			seek TEMP, 0, 0;
			while( read(YABB_FILE,$buffer,1024) ) 
				{
				print TEMP $buffer;
				}
			truncate YABB_FILE, 0;
			seek YABB_FILE, 0, 0;
			seek TEMP, 0, 0;
			my $new_count = 0;
			while( $line = <TEMP> ) 
				{
				if($new_count != 6)
					{
					print YABB_FILE $line;
					}
				else
					{
					chomp $line;
					$line = "$line" - $YaBB_UPP_tmp;
					print YABB_FILE qq~$line\n~;
					}
				$new_count++;
				}
			close(YABB_FILE);
			close(TEMP);
			if (-e "$CConfig{'YaBB_Abs_Path'}/Members/$YaBB_User.dat.temp") 
				{
				unlink("$CConfig{'YaBB_Abs_Path'}/Members/$YaBB_User.dat.temp"); 
				}
			}

		# Remove thread files
		if (-e "$CConfig{'YaBB_Abs_Path'}/Messages/$CustomField_YaBB_ID.txt") 
			{
			unlink("$CConfig{'YaBB_Abs_Path'}/Messages/$CustomField_YaBB_ID.txt");
			}
		if (-e "$CConfig{'YaBB_Abs_Path'}/Messages/$CustomField_YaBB_ID.mail") 
			{
			unlink("$CConfig{'YaBB_Abs_Path'}/Messages/$CustomField_YaBB_ID.mail");
			}
		if (-e "$CConfig{'YaBB_Abs_Path'}/Messages/$CustomField_YaBB_ID.data") 
			{
			unlink("$CConfig{'YaBB_Abs_Path'}/Messages/$CustomField_YaBB_ID.data");
			}
		}
	}

sub YaBB_PostNews {

			my $YText = $in{'Text'};
			$YText =~ s/<br>/\n/ig;
			$YText =~ s/[\n]/[br]/ig;
			$YText =~ s/[\r]//ig;
			$YText =~ s/<hr>/[hr]/ig;
			$YText =~ s/\<a href="mailto:([^">].*?)"\>([^<].*?)\<\/a\>/\[email\]$1\[\/email\]/ig;
			$YText =~ s/<a href="([^"].*?)"([^>].*?)?\>([^<].*?)<\/a>/\[url=$1\]$3\[\/url\]/ig;
			$YText =~ s/<img src="([^"].*?)"([^>].*?)?>/\[img\]$1 \[\/img\]/ig;
			$YText =~ s/<a name([^>].*?)>([^<].*?)<\/a>/$2/ig;
			$YText =~ s/<b>/[b]/ig;
			$YText =~ s/<\/b>/[\/b]/ig;
			$YText =~ s/<i>/[i]/ig;
			$YText =~ s/<\/i>/[\/i]/ig;
			$YText =~ s/<u>/[u]/ig;
			$YText =~ s/<\/u>/[\/u]/ig;
			$YText =~ s/<ol([^>].*?)?>/[list]/ig;
			$YText =~ s/<ul([^>].*?)?>/[list]/ig;
			$YText =~ s/<li([^>].*?)?>/[*]/ig;
			$YText =~ s/<\/ol>/[\/list]/ig;
			$YText =~ s/<\/ul>/[\/list]/ig;
			$YText =~ s/<code([^>].*?)?>//ig;
			$YText =~ s/<\/code>//ig;
			$YText =~ s/<tt([^>].*?)?>//ig;
			$YText =~ s/<\/tt>//ig;
			$YText =~ s/<font([^>].*?)>//ig;
			$YText =~ s/<\/font>//ig;
			$YText =~ s/<table([^>].*?)>/[table]/ig;
			$YText =~ s/<\/table>/[\/table]/ig;
			$YText =~ s/<tr([^>].*?)?>/\[tr\]/ig;
			$YText =~ s/<th([^>].*?)?>/[td]/ig;
			$YText =~ s/<td([^>].*?)?>/[td]/ig;
			$YText =~ s/<\/tr>/[\/tr]/ig;
			$YText =~ s/<\/td>/[\/td]/ig;
			$YText =~ s/<\/th>/[\/td]/ig;
			$YText =~ s/<([^>].*?)?>//ig;

	my ($email, $ns, $notify, @memberlist, $i, $realname, $membername, $testname, @reserve, @reservecfg, $matchword, $matchcase, $matchuser, $matchname, $namecheck, $reserved, $reservecheck, @messages, $mnum, $msub, $mname, $memail, $mdate, $musername, $micon, $mstate, $pageindex, $tempname);

	$currentboard = $CustomField_YaBB_Board;

	&Y_BoardTotals("load", $currentboard);

	# Get the form values
	$name       = $YaBB_User;
	$email      = $YaBB_UserEmail;
	$subject    = $in{'Subject'};
	$message    = $YText;
	$icon       = "xx";
	$ns         = "";
	$ann        = "";
	$threadid   = $yabbnewthreadid;
	$pollthread = 0;
	if ($threadid =~ /\D/) { &fatal_error($post_txt{'337'}); }
	$notify    = "";
	$thestatus = "";
	$thestatus =~ s/\, //g;
	$username = $YaBB_User;
	$currentboard = $CustomField_YaBB_Board;

	if ($name && $email) {
		&ToHTML($name);
		$email =~ s/\|//g;
		&ToHTML($email);
		$tempname = $name;
		$name =~ s/\_/ /g;
	}

	if ($pollthread != 2) {    # If user is NOT adding a Poll to an existing thread
		# Check Message Length Precisely
		$mess_len = $message;
		$mess_len =~ s/[\r\n]//g;

		my $testsub = $subject;
		$testsub =~ s/[\r\n\ ]//g;
		$testsub =~ s/\&nbsp;//g;
		$testsub =~ s/ //g;

		if ($testsub eq "" && $pollthread != 2) { fatal_error("$maintxt{'2'} $testsub"); }
		my $testmessage = $message;
		$testmessage =~ s/[\r\n\ ]//g;
		$testmessage =~ s/\&nbsp;//g;
		$testmessage =~ s~\[table\].*?\[tr\].*?\[td\]~~g;
		$testmessage =~ s~\[/td\].*?\[/tr\].*?\[/table\]~~g;
		$testmessage =~ s/\[.*?\]//g;
		if ($testmessage eq "" && $message ne "" && $pollthread != 2) { fatal_error("$maintxt{'2'} $testmessage"); }

		$subject =~ s/&amp;/&/g;
		$subject =~ s/&quot;/"/g;
		$subject =~ s/&lt;/</g;
		$subject =~ s/&gt;/>/g;
		&FromChars($subject);
		$convertstr = $subject;
		$convertcut = 50;
		&CountChars;
		$subject = $convertstr;
		$subject =~ s/"/&quot;/g;
		$subject =~ s/</&lt;/g;
		$subject =~ s/>/&gt;/g;

		$subject =~ s/[\r\n]//g;
		$doadsubject = $subject;
		$message =~ s/\cM//g;
		$message =~ s~\[([^\]]{0,30})\n([^\]]{0,30})\]~\[$1$2\]~g;
		$message =~ s~\[/([^\]]{0,30})\n([^\]]{0,30})\]~\[/$1$2\]~g;
		$message =~ s~(\w+://[^<>\s\n\"\]\[]+)\n([^<>\s\n\"\]\[]+)~$1\n$2~g;
		&FromChars($message);
		&ToHTML($message);
		$message =~ s~\t~ \&nbsp; \&nbsp; \&nbsp;~g;
		$message =~ s~\n~<br />~g;
		$message =~ s/([\000-\x09\x0b\x0c\x0e-\x1f\x7f])/\x0d/g;
		&CheckIcon;

		if (-e ("$datadir/.txt")) { unlink("$datadir/.txt"); }

	}    # end if


	# If no thread specified, this is a new thread.
	# Find a valid random ID for it.
	if ($threadid eq '') {
		$newthreadid = &getnewid;
	} else {
		$newthreadid = '';
	}
	$mreplies = 0;

	# set announcement flag according to status of current board
	if ($newthreadid) {
		$mstate = "0$thestatus";
		if ($currentboard eq $annboard) { $mstate = "0a"; }

		# This is a new thread. Save it.
		fopen(FILE, "+<$boardsdir/$currentboard.txt", 1) or die "Can't open $boardsdir/$currentboard.txt line 476 : $!";
		seek FILE, 0, 0;
		my @buffer = <FILE>;
		truncate FILE, 0;
		seek FILE, 0, 0;
		print FILE qq~$newthreadid|$subject|$name|$email|$date|0|$username|$icon|$mstate\n~;
		print FILE @buffer;
		fclose(FILE);
		fopen(FILE, ">$datadir/$newthreadid.txt") || &write_error("$post_txt{'23'} $newthreadid.txt", 1);
		print FILE qq~$subject|$name|$email|$date|$username|$icon|0|$user_ip|$message|$ns|||$fixfile\n~;
		fclose(FILE);
		$mreplies = 0;

		if ($file) {
			fopen(AMP, ">>$vardir/attachments.txt") || &write_error("209 $txt{'106'}: $txt{'23'} $vardir/attachments.txt");
			print AMP qq~$newthreadid|$mreplies|$subject|$name|$currentboard|$filesizekb|$date|$fixfile\n~;
			fclose(AMP);
		}
		if ($pollthread) {    # Save Poll data for new thread
			fopen(POLL, ">$datadir/$newthreadid.poll");
			print POLL @poll_data;
			fclose(POLL);
		}
		## write the ctb file for the new thread
		${$newthreadid}{'board'}        = $currentboard;
		${$newthreadid}{'replies'}      = 0;
		${$newthreadid}{'views'}        = 0;
		${$newthreadid}{'lastposter'}   = $iamguest ? qq~Guest-$name~ : $username;
		${$newthreadid}{'lastpostdate'} = "$newthreadid";
		${$newthreadid}{'threadstatus'} = "$mstate";

		&MessageTotals("update", $newthreadid);

	} else {
		# This is an old thread. Save it.
		# first load the current ctb info on this existing thread.
		&MessageTotals("load", $threadid);

		# Check if thread has moved. And do necessary access check
		if ("${$threadid}{'board'}" ne "$currentboard") {

			# Thread has moved, but we can still post
			# the current board is now the new board.
			$currentboard = ${$threadid}{'board'};
		}

			# Save new reply data
			($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate) = split(/\|/, $yyThreadLine);
			$mreplies = ${$threadid}{'replies'};
			if ($mstate =~ /l/i) { &fatal_error($post_txt{'90'}); }
			$mstate = "0$thestatus";
			if ($currentboard eq $annboard && $mstate !~ /a/i) { $mstate = "0a"; }
			$mreplies++;
			fopen(BOARDFILE, "+<$boardsdir/$currentboard.txt", 1) or die "Can't open $boardsdir/$currentboard.txt line 529 : $!";
			seek BOARDFILE, 0, 0;
			my @buffer = <BOARDFILE>;
			truncate BOARDFILE, 0;

			for ($i = 0; $i < @buffer; $i++) {
				if ($buffer[$i] =~ m~\A$mnum\|~o) { $buffer[$i] = ""; last; }
			}
			seek BOARDFILE, 0, 0;
			print BOARDFILE qq~$mnum|$msub|$mname|$memail|$date|$mreplies|$musername|$micon|$mstate\n~;
			print BOARDFILE @buffer;
			fclose(BOARDFILE);
			fopen(THREADFILE, ">>$datadir/$threadid.txt") || &write_error("212 $post_txt{'106'}: $post_txt{'23'} $threadid.txt", 1);
			print THREADFILE qq~$subject|$name|$email|$date|$username|$icon|0|$user_ip|$message|$ns|||$fixfile\n~;
			fclose(THREADFILE);

		# update the ctb file for the existing thread with number of replies and lastposter
		${$threadid}{'board'}        = $currentboard;
		${$threadid}{'replies'}      = $mreplies;
		${$threadid}{'lastposter'}   = $iamguest ? qq~Guest-$name~ : $username;
		${$threadid}{'lastpostdate'} = "$date";
		${$threadid}{'threadstatus'} = "$mstate";

		&MessageTotals("update", $threadid);
		&ReplyNotify($threadid, $subject);
	}    # end else

	if (!$iamguest) {

		# Increment post count and lastpost date for the member.

		$Y_User	{'postcount'}++;
			&UserAccount($username, "update", "lastpost");
			&UserAccount($username, "update", "lastonline");

			if ($Y_User{'position'}) {
				$grp_after = qq~$Y_User{'position'}~;
			} else {
				foreach $postamount (sort { $b <=> $a } keys %Post) {
					if ($Y_User{'postcount'} > $postamount) {
						($title, undef) = split(/\|/, $Post{$postamount}, 2);
						$grp_after = $title;
						last;
					}
				}
			}
			&ManageMemberinfo("update", $username, '', '', $grp_after, $Y_User{'postcount'});
	}

	# The thread ID, regardless of whether it's a new thread or not.
	$thread = $newthreadid || $threadid;

	# Mark thread as read for the member.
	&dumplog($currentboard, $date);

	&doaddition;
	if(!$iamguest) { &Recent_Write("incr", $thread, $username); }
}

sub doaddition {
	${$uid.$currentboard}{'messagecount'}++;
	unless ($FORM{'threadid'}) {
		$Y_Boards{'threadcount'}++;
		++$threadcount;
	}
	$myname = $iamguest ? qq~Guest-$name~ : $username;
	$Y_Boards{'lastposttime'} = $date;
	$Y_Boards{'lastposter'}   = $myname;
	$Y_Boards{'lastpostid'}   = $thread;
	$Y_Boards{'lastreply'}    = $mreplies;
	$Y_Boards{'lastsubject'}  = $doadsubject;
	$Y_Boards{'lasticon'}     = $icon;

	&Y_BoardTotals("update", $currentboard);
}

sub LoadMyUser {
		$user = $CConfig{'YaBB_User'};
		fopen(LOADUSER, "$memberdir/$CConfig{'YaBB_User'}.vars");
		my @settings = <LOADUSER>;
		fclose(LOADUSER);
		$output = "";
		foreach $setting (@settings) {
			chomp $setting;
			unless (length($setting) == 0) {
				$setting =~ s/\'(.*?)\'\,\"(.*?)\"//ig;
				my $tag   = $1;
				my $value = $2;
				$Y_User{$tag} = $value;
				$output .= qq~$tag = $Y_User{$tag}\n~;
			}
		}

}

sub Y_BoardTotals {
	my ($job, @updateboards) = @_;
	my ($testboard, $line, @lines, $updateboard, @boardvars, $tag, $cnt);
	if (@updateboards) {
		if ($job eq "load") {
			fopen(FORUMTOTALS, "$boardsdir/forum.totals") or die "Unable to open $boardsdir/forum.totals line 630 : $!";
			@lines = <FORUMTOTALS>;
			fclose(FORUMTOTALS);
			my @tags = qw(board threadcount messagecount lastposttime lastposter lastpostid lastreply lastsubject lasticon);
			foreach $line (@lines) {
				chomp $line;
				(@boardvars) = split(/\|/, $line);
				foreach $updateboard (@updateboards) {
					chomp $updateboard;
					if ($boardvars[0] eq $updateboard && exists($board{ $boardvars[0] })) {
						$loadedboards++;
						for ($cnt = 1; $cnt < $#tags; $cnt++) {
							$Y_Board{ $tags[$cnt] } = $boardvars[$cnt];
							$output .= qq~Board Info $cnt = $boardvars[$cnt]\n~;
						}
					}
				}
			}
		}
		if ($job eq "update") {
			fopen(FORUMTOTALS, "+<$boardsdir/forum.totals") or die "Can't open $boardsdir/forum.totals line 649 : $!";
			seek FORUMTOTALS, 0, 0;
			@lines = <FORUMTOTALS>;
			truncate FORUMTOTALS, 0;
			seek FORUMTOTALS, 0, 0;
			my @tags = qw(board threadcount messagecount lastposttime lastposter lastpostid lastreply lastsubject lasticon);
			print FORUMTOTALS "$updateboards[0]|";
			for ($cnt = 1; $cnt <= $#tags; $cnt++) {
				print FORUMTOTALS $Y_Board{ $tags[$cnt] };
				if ($cnt < $#tags) { print FORUMTOTALS "|"; }
			}
			print FORUMTOTALS "\n";
			foreach $line (@lines) {
				chomp $line;
				(@boardvars) = split(/\|/, $line);
				if ($boardvars[0] ne $updateboards[0] && exists($board{ $boardvars[0] })) {
					print FORUMTOTALS "$line\n";
					$loadedboards++;
				}
			}
			fclose(FORUMTOTALS);
		}
		if ($job eq "delete") {
			fopen(FORUMTOTALS, "$boardsdir/forum.totals");
			seek FORUMTOTALS, 0, 0;
			@lines = <FORUMTOTALS>;
			truncate FORUMTOTALS, 0;
			seek FORUMTOTALS, 0, 0;
			foreach $line (@lines) {
				chomp $line;
				(@boardvars) = split(/\|/, $line);
				if ($boardvars[0] ne $updateboards[0] && exists($board{ $boardvars[0] })) {
					print FORUMTOTALS "$line\n";
					$loadedboards++;
				}
			}
			fclose(FORUMTOTALS);
		}
		if ($job eq "add") {
			fopen(FORUMTOTALS, "$boardsdir/forum.totals");
			seek FORUMTOTALS, 0, 0;
			@lines = <FORUMTOTALS>;
			truncate FORUMTOTALS, 0;
			seek FORUMTOTALS, 0, 0;
			print FORUMTOTALS "$updateboards[0]|0|0|N/A|N/A||||\n";
			print FORUMTOTALS @lines;
			fclose(FORUMTOTALS);
		}
	}
}

1;

=head1 YaBB comments

=head2 Description & Usage

This addon enables you to use YaBB forum for news comments. 
As you submit/modify news you will notice some new fields in the form. The one called 'YaBB_ID#' you don't normally need to use. The second 'YaBB Board' is there because Coranto's dropdown boxes are not flexible enough and the addon uses Coranto's database to store information.
If the newsitem has a thread you will not see the board selection dropdown box, but if you have selected not to create a thread for the newsitem when you created it, you may do so on the modify page by selecting a board for the thread.

YaBB-files are accessed directly, so you will have to provide some settings in 'Change Settings'. 
When you submit a newsitem, a thread is automatically created in the chosen board. 
Modifying a news item will modify the corresponding post and include a notice of modification in the last line of the post. 
Deleting a newsitem will also delete the entire thread, if you so choose.

NOTE! If you remove comment threads directly from YaBB, you will end up having a broken comments-link for the newsitem.
Modifying the newsitem will automatically create a new thread to replace the missing one.

=head2 Setup & Configuration

The settings are simple enough in the 'Change Settings' area. The 'YaBB Board' is the default value for the board selection on submit page (leave empty to default to not creating a new thread).
If you do not want to have the poster appear as a guest, you can create an account in YaBB with the same username (max 18 characters, no spaces and special characters).
You can also to make 2 new userfields manually, if you want to use individual YaBB-accounts for each user. 
Name them "YaBB_UserName" and "YaBB_UserEmail" (without the quotes). The values in 'Change Settings' will be used if the user does not provide YaBB-account information.

If you want to show the count of comments for any particular newsitem, here's how to do it: 

	1. Configure and upload the included replies.pl to your Coranto folder.
	2. Create a profile which creates an shtml-file (e.g. news.shtml) and replace news.txt with it on your news page.
	3. Edit your news style to include (replacing path to replies.pl with your path):

	<If: Field: CustomField_YaBB_ID>&nbsp;&nbsp;-&nbsp;&nbsp;<a href="
	<PerlCode>
	$newshtml .= "$CConfig{'YaBB_Path'}/YaBB.pl?board=$CustomField_YaBB_Board\&action=display&num=";
	</PerlCode><Field: CustomField_YaBB_ID>" target=_blank>Comments <!--#config errmsg="(N/A)" --><!--#include virtual="/cgi-bin/coranto/replies.pl?<Field: CustomField_YaBB_ID>,<Field: CustomField_YaBB_Board>"--></a></If>

If you don't care about the replycount, you can simply edit your news style to include:

	<If: Field: CustomField_YaBB_ID><a href="<PerlCode>
	$newshtml .= "$CConfig{'YaBB_Path'}/YaBB.pl?board=$CustomField_YaBB_Board\&action=display&num=";
	</PerlCode><Field: CustomField_YaBB_ID>" target=_blank>Comments</a></If>
